MEMORY_DEBUG_TESTS ?= $(TESTS)
MEMORY_DEBUG_TESTS_ENVIRONMENT ?= $(TESTS_ENVIRONMENT)

memcheck: libumem-memcheck
mtsafe:

libumem-memcheck:
	$(MAKE) \
	  LIBUMEM_TOOL=libumem-memcheck \
          LIBUMEM_ENV="UMEM_DEBUG=default,firewall=1 UMEM_OPTIONS=backend=mmap UMEM_LOGGING=transaction" \
	  libumem-doit

libumem-doit: $(MEMORY_DEBUG_TESTS)
	echo $(MEMORY_DEBUG_LD_LIBRARY_PATH)
	for x in $(MEMORY_DEBUG_TESTS);				\
	do							\
	  if test -x .libs/lt-$$x;				\
	  then							\
	    cmd=".libs/lt-$$x";					\
	  elif test -x .libs/$x;				\
	  then							\
	    cmd=".libs/$$x";					\
	  else							\
	    cmd=".libs/$$x";					\
	  fi;							\
	  echo $(MEMORY_DEBUG_TESTS_ENVIRONMENT)			\
	    env $(LIBUMEM_ENV)                                      \
	    LD_LIBRARY_PATH="$(MEMORY_DEBUG_LD_LIBRARY_PATH):$${LD_LIBRARY_PATH}" \
	    LD_PRELOAD=$(LIBUMEM)				\
            $$cmd;						\
	  $(MEMORY_DEBUG_TESTS_ENVIRONMENT)			\
	    env $(LIBUMEM_ENV)                                  \
	    LD_LIBRARY_PATH="$(MEMORY_DEBUG_LD_LIBRARY_PATH):$${LD_LIBRARY_PATH}" \
	    LD_PRELOAD=$(LIBUMEM)				\
            $$cmd > $$cmd.$(LIBUMEM_TOOL) 2>&1;			\
	done
